import 'package:flutter/material.dart';
import 'package:yin_ui/actionsheet/index.dart';
import 'package:yin_ui/utils.dart';

final double _leftPadding = 18.0;
final double _topPadding = 12.0;

List<Widget> initChilder(
  List<WeActionSheetItem> options,
  onChange,
  Color borderColor, {
  Alignment align = Alignment.center,
}) {
  final List<Widget> childs = [];

  options.forEach((it) {
    if (childs.length > 0) {
      childs.add(Divider(height: 1, color: borderColor));
    }

    childs.add(InkWell(
      onTap: () => onChange(options.indexOf(it)),
      child: Container(
        alignment: align,
        padding: EdgeInsets.symmetric(horizontal: _leftPadding, vertical: _topPadding),
        child: DefaultTextStyle(
          style: TextStyle(fontSize: 16.0, color: Colors.black87),
          child: toTextWidget(it.label, 'options'),
        ),
      ),
    ));
  });

  return childs;
}
