import 'package:flutter/material.dart';
import 'package:yin_ui/utils.dart';

///单选
class WeCheckBox extends StatelessWidget {
  final dynamic child;
  final bool checked;
  final Function onChange;
  final CrossAxisAlignment alignment;

  WeCheckBox({
    @required this.child,
    this.checked = false,
    this.onChange,
    this.alignment = CrossAxisAlignment.start,
  });

  @override
  Widget build(BuildContext context) {
    Widget iconView;
    if (checked) {
      iconView = Icon(Icons.check_circle, color: Colors.green);
    } else {
      iconView = Icon(Icons.radio_button_unchecked, color: Colors.grey);
    }

    Widget spaceView = SizedBox(width: 10);

    Widget textView = DefaultTextStyle(
      style: TextStyle(fontSize: 14, color: Colors.black87),
      child: toTextWidget(child, 'checkbox child'),
    );

    List<Widget> children = [iconView, spaceView, Expanded(child: textView)];

    Widget view = Row(
      children: children,
      mainAxisSize: MainAxisSize.min,
      crossAxisAlignment: alignment,
    );

    if (onChange is Function) {
      return GestureDetector(onTap: onChange, child: view);
    } else {
      return Opacity(opacity: 0.6, child: view);
    }
  }
}
