import 'package:flutter/material.dart';

import 'package:yin_ui/dialog/layout_hoc.dart';

import 'package:yin_ui/animation/fade_in.dart';
import 'package:yin_ui/animation/scale.dart';
import 'package:yin_ui/theme/index.dart';
import 'package:yin_ui/dialog/index.dart';

///自定义视图
class CustomWidget extends StatefulWidget {
  //自定义视图
  final Widget child;

  //关闭
  final Function onMaskCLick;

  //显示样式
  final WeDialogModel model;

  CustomWidget({
    key,
    this.child,
    this.onMaskCLick,
    this.model,
  }) : super(key: key);

  @override
  CustomWidgetState createState() => new CustomWidgetState();
}

class CustomWidgetState extends State<CustomWidget> {
  final GlobalKey _fadeInKey = GlobalKey();
  final GlobalKey _scaleKey = GlobalKey();
  WeTheme theme;

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    theme = WeUI.getTheme(context);
  }

  // 反向执行动画
  reverseAnimation() async {
    (_scaleKey.currentState as ScaleState).controller.reverse();
    if (widget.model == WeDialogModel.overlay) {
      await (_fadeInKey.currentState as FadeInState).controller.reverse();
    }
  }

  @override
  Widget build(BuildContext context) {
    return layoutHoc(
      scaleKey: _scaleKey,
      fadeInKey: _fadeInKey,
      maskColor: theme.maskColor,
      children: [widget.child],
      onMaskCLick: widget.onMaskCLick,
      model: widget.model,
    );
  }
}
