import 'package:flutter/material.dart';
import 'package:yin_ui/drawer/drawer.dart';
import 'package:yin_ui/utils.dart';

typedef ShowDrawer = Function({
//是否显示mask
  bool mask,
//遮层点击关闭
  bool maskClosable,
//显示模式
  WeDrawerModel model,
//方向
  WeDrawerPlacement placement,
//显示子视图
  @required Widget child,
});

typedef CloseDrawer = Function();

ShowDrawer weDrawer(BuildContext context) {
  final GlobalKey widgetKey = GlobalKey();

  CloseDrawer showDrawer({
    mask = true,
    maskClosable = true,
    model: WeDrawerModel.dialog,
    placement = WeDrawerPlacement.bottom,
    onClose,
    child,
  }) {
    Function remove;

    close() async {
      await (widgetKey.currentState as DrawerWidgetState).reverseAnimation();
      if (onClose is Function) onClose();
      remove();
    }

    Widget widgetChild = DrawerWidget(
      key: widgetKey,
      mask: mask,
      placement: placement,
      model: model,
      maskClick: maskClosable ? close : null,
      child: child,
    );

    if (model == WeDrawerModel.dialog) {
      remove = createDialog(
        context: context,
        barrierDismissible: true,
        child: widgetChild,
        willPopCallback: close,
      );
    } else {
      remove = createOverlayEntry(
        context: context,
        child: widgetChild,
        willPopCallback: close,
      );
    }

    return close;
  }

  return showDrawer;
}
