import 'package:flutter/material.dart';
import 'package:yin_ui/image_preview/preview_widget.dart';

import '../utils.dart';

//默认背景颜色
const Color _maskColor = Color.fromRGBO(0, 0, 0, 0.8);

typedef WeImagePreview = Function({
//图片
  List<String> images,
//背景颜色
  Color color,
//默认展示
  int defaultIndex,
//指示显示
  bool indicators,
//指示颜色
  Color indicatorsColor,
//图片类型
  PreviewType type,
//自定义item
  void itemBuild,
});

WeImagePreview weImagePreview(BuildContext context) {
  final GlobalKey widgetKey = GlobalKey();

  Function remove;

  Function show({
    images,
    color = _maskColor,
    defaultIndex = 0,
    indicators = true,
    indicatorsColor = Colors.white,
    type = PreviewType.network,
    itemBuild,
  }) {
    close() async {
      await (widgetKey.currentState as PreviewState).reverseAnimation();
      remove();
    }

    remove = createOverlayEntry(
      context: context,
      child: Preview(
        key: widgetKey,
        images: images,
        color: color,
        maskClick: close,
        defaultIndex: defaultIndex,
        indicators: indicators,
        indicatorsColor: indicatorsColor,
        type: type,
        itemBuild: itemBuild,
      ),
    );

    return close;
  }

  return show;
}
