import 'package:flutter/material.dart';

class WeNumber extends StatelessWidget {
  final double size;
  final int initNumber;
  final int maxTop;
  final Function(int index) onChange;

  WeNumber({
    this.size = 24,
    this.initNumber = 0,
    this.maxTop = 10000,
    this.onChange,
  });

  @override
  Widget build(BuildContext context) {
    Widget leftView = InkWell(
      onTap: () => click(initNumber - 1),
      child: Container(
        height: size,
        width: size,
        decoration: BoxDecoration(
          borderRadius: BorderRadius.all(Radius.circular(2)),
          color: Colors.grey[100],
        ),
        child: Icon(Icons.remove, color: initNumber <= 1 ? Colors.black26 : Colors.black87, size: size - 2),
      ),
    );

    Widget numberView = Container(
      height: size,
      constraints: BoxConstraints(
        minWidth: size * 1.2,
      ),
      padding: EdgeInsets.only(left: 2, right: 2),
      margin: EdgeInsets.only(left: 2, right: 2),
      alignment: Alignment.center,
      decoration: BoxDecoration(
        borderRadius: BorderRadius.all(Radius.circular(2)),
        color: Colors.grey[100],
      ),
      child: Text(
        '$initNumber',
        style: TextStyle(fontSize: 14, color: Colors.black87),
        maxLines: 1,
        overflow: TextOverflow.ellipsis,
      ),
    );

    Widget rightView = InkWell(
      onTap: () => click(initNumber + 1),
      child: Container(
        height: size,
        width: size,
        decoration: BoxDecoration(
          borderRadius: BorderRadius.all(Radius.circular(2)),
          color: Colors.grey[100],
        ),
        child: Icon(Icons.add, color: initNumber >= maxTop ? Colors.black26 : Colors.black87, size: size - 2),
      ),
    );

    List<Widget> children = [leftView, numberView, rightView];

    return Row(children: children, mainAxisSize: MainAxisSize.min);
  }

  void click(int index) {
    if (index <= 0) return;
    if (index > maxTop) return;
    if (onChange is Function) {
      onChange(index);
    }
  }
}
