//间距
import 'package:flutter/material.dart';
import 'package:yin_ui/tip/WeTipWidget.dart';
import 'package:yin_ui/utils.dart';

//方向
enum WeTipPlacement { top, right, bottom, left }

class WeTip extends StatefulWidget {
  //位置
  final WeTipPlacement placement;

  //元素
  final Widget child;

  //提示内容
  final Widget content;

  WeTip({
    this.placement = WeTipPlacement.top,
    this.child,
    this.content,
  });

  @override
  WeTipState createState() => WeTipState();
}

class WeTipState extends State<WeTip> {
  GlobalKey _boxKey = GlobalKey();
  Function remove;

  void show() {
    remove = createOverlayEntry(
      context: context,
      child: WeTipWidget(
        maskClick: close,
        boxContext: _boxKey.currentContext,
        placement: widget.placement,
        child: widget.content,
      ),
    );
  }

  void close() {
    remove();
  }

  @override
  Widget build(BuildContext context) {
    return Row(
      mainAxisSize: MainAxisSize.min,
      children: <Widget>[
        Column(
          mainAxisSize: MainAxisSize.min,
          children: <Widget>[
            GestureDetector(
              key: _boxKey,
              onTap: show,
              child: widget.child,
            )
          ],
        ),
      ],
    );
  }
}
